package com.madeu.controller.web.webappcontents;

import com.madeu.constants.Constants;
import com.madeu.init.ManagerDraftAction;
import com.madeu.service.web.webappcontents.WebAppContentsService;
import com.madeu.service.web.webloghistory.WebLogHistoryService;
import com.madeu.util.HttpUtil;
import com.madeu.util.RequestLogUtil;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.servlet.http.HttpSession;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.servlet.ModelAndView;

import java.util.HashMap;
@Slf4j
@Controller
public class WebAppContentsController extends ManagerDraftAction {

    @Autowired
    private WebAppContentsService webAppContentsService;

    @Autowired
    private WebLogHistoryService webLogHistoryService;

    /**
     * 콘텐츠관리 리스트 화면으로 이동.
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webappcontents/selectListContentsIntro.do")
    public String  selectListAppContentsIntro(HttpSession session, HttpServletRequest request, HttpServletResponse response, Model model) {
        log.debug("WebAppContentsController  selectListAppContentsIntro START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            if(!webCheckLogin(session)){
                return "/web/login/logout";
            }
            else {
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                map = webAppContentsService.selectListAppContentsIntro(paramMap);

                model.addAttribute("selectUseYn", map.get("selectUseYn"));
                model.addAttribute("insertUseYn", map.get("insertUseYn"));
                model.addAttribute("updateUseYn", map.get("updateUseYn"));
                model.addAttribute("deleteUseYn", map.get("deleteUseYn"));
                model.addAttribute("downloadUseYn", map.get("downloadUseYn"));
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            return "/web/login/logout";
        }
        log.debug("WebAppContentsController  selectListAppContentsIntro END");
        return "/web/appcontents/appContentsSelectList";
    }

    /**
     * 앱 이벤트 정보 리스트 조회
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webappcontents/selectListAppContents.do")
    public ModelAndView selectListAppContents(HttpSession session, HttpServletRequest request, HttpServletResponse response) {
        log.debug("WebAppContentsController selectListAppContents START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            if(!webCheckLogin(session)){
                return null;
            }
            else{
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                map = webAppContentsService.selectListAppContents(paramMap);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            return null;
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }
        }
        log.debug("WebAppContentsController selectListAppContents END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }
    
    /**
     * 콘텐츠 상세 등록 화면으로 이동.
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webappcontents/insertContentsIntro.do")
    public String  insertContentsIntro(HttpSession session, HttpServletRequest request, HttpServletResponse response, Model model) {
        log.debug("WebAppContentsController  insertContentsIntro START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            if(!webCheckLogin(session)){
                return "/web/login/logout";
            }
            else {
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                map = webAppContentsService.insertAppContentsIntro(paramMap);

                model.addAttribute("selectUseYn", map.get("selectUseYn"));
                model.addAttribute("insertUseYn", map.get("insertUseYn"));
                model.addAttribute("updateUseYn", map.get("updateUseYn"));
                model.addAttribute("deleteUseYn", map.get("deleteUseYn"));
                model.addAttribute("downloadUseYn", map.get("downloadUseYn"));
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            return "/web/login/logout";
        }
        log.debug("WebAppContentsController  insertContentsIntro END");
        return "/web/appcontents/appContentsInsert";
    }

    /**
     * 콘텐츠 상세 수정 화면으로 이동.
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webappcontents/updateContentsIntro.do")
    public String  updateContentsIntro(HttpSession session, HttpServletRequest request, HttpServletResponse response, Model model) {
        log.debug("WebAppContentsController  updateContentsIntro START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            if(!webCheckLogin(session)){
                return "/web/login/logout";
            }
            else {
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                map = webAppContentsService.updateAppContentsIntro(paramMap);

                model.addAttribute("selectUseYn", map.get("selectUseYn"));
                model.addAttribute("insertUseYn", map.get("insertUseYn"));
                model.addAttribute("updateUseYn", map.get("updateUseYn"));
                model.addAttribute("deleteUseYn", map.get("deleteUseYn"));
                model.addAttribute("downloadUseYn", map.get("downloadUseYn"));
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            return "/web/login/logout";
        }
        log.debug("WebAppContentsController  updateContentsIntro END");
        return "/web/appcontents/appContentsUpdate";
    }

    /**
     * 엡 콘텐츠 정보 상세 조회
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webappcontents/selectAppContents.do")
    public ModelAndView selectAppContents(HttpSession session, HttpServletRequest request, HttpServletResponse response) {
        log.debug("WebAppContentsController selectAppContents START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            if(!webCheckLogin(session)){
                return null;
            }
            else{
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                map = webAppContentsService.selectAppContents(paramMap);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            return null;
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }
        }
        log.debug("WebAppContentsController selectAppContents END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }

    /**
     * 앱 콘텐츠 상세 이미지 파일 저장
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webappcontents/uploadFile.do")
    public ModelAndView uploadFile(HttpSession session,HttpServletRequest request, HttpServletResponse response,@RequestParam(value = "file", required = false) MultipartFile file) {
        log.debug("WebAppContentsController uploadFile START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        StringBuffer errorMsg = new StringBuffer();

        try{
            if(!webCheckLogin(session)){
                return null;
            }
            else{
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                paramMap.put("regId", String.valueOf(session.getAttribute("loginMemberId")));
                paramMap.put("modId", String.valueOf(session.getAttribute("loginMemberId")));
                map = webAppContentsService.uploadFile(paramMap,file);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            errorMsg.append(e);
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }

            try {
                HashMap<String, Object> visitLogParamMap = RequestLogUtil.getVisitLogParameterMap(request);
                HashMap<String, Object> insertMap = new HashMap<String, Object>();

                insertMap.put("url", "/webappcontents/uploadFile.do");
                insertMap.put("func", "uploadFile");
                insertMap.put("funcName", "앱 콘텐츠 상세 이미지파일 저장");
                insertMap.put("service", "webAppContentsService");
                insertMap.put("serviceName", "앱 콘텐츠 등록");
                insertMap.put("requestValue", String.valueOf(paramMap));
                insertMap.put("responseValue", String.valueOf(map));
                insertMap.put("tId", map.get("tId"));
                if((String.valueOf(errorMsg)).equals("") || (String.valueOf(errorMsg) == null) || String.valueOf(errorMsg).length() == 0){
                    insertMap.put("resultCode", "SUCCESS");
                }
                else{
                    insertMap.put("resultCode", "ERROR");
                }
                insertMap.put("resultMsg", String.valueOf(errorMsg));
                insertMap.put("muMemberId", paramMap.get("loginMemberId"));

                webLogHistoryService.insertLogHistory(insertMap, visitLogParamMap);
            }
            catch (Exception e) {
                e.printStackTrace();
            }
        }
        log.debug("WebAppContentsController uploadFile END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }
    /**
     * 앱 콘텐츠 정보 등록
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webappcontents/insertAppContents.do")
    public ModelAndView insertAppContents(HttpSession session,HttpServletRequest request, HttpServletResponse response,@RequestParam(value = "file", required = false) MultipartFile file,@RequestParam(value = "file2", required = false) MultipartFile file2) {
        log.debug("WebAppContentsController insertAppContents START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        StringBuffer errorMsg = new StringBuffer();

        try{
            if(!webCheckLogin(session)){
                return null;
            }
            else{
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                paramMap.put("regId", String.valueOf(session.getAttribute("loginMemberId")));
                paramMap.put("modId", String.valueOf(session.getAttribute("loginMemberId")));
                map = webAppContentsService.insertAppContents(paramMap,file, file2);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            errorMsg.append(e);
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }

            try {
                HashMap<String, Object> visitLogParamMap = RequestLogUtil.getVisitLogParameterMap(request);
                HashMap<String, Object> insertMap = new HashMap<String, Object>();

                insertMap.put("url", "/webappcontents/insertAppContents.do");
                insertMap.put("func", "insertAppContents");
                insertMap.put("funcName", "앱 콘텐츠 등록");
                insertMap.put("service", "webAppContentsService");
                insertMap.put("serviceName", "앱 콘텐츠 등록");
                insertMap.put("requestValue", String.valueOf(paramMap));
                insertMap.put("responseValue", String.valueOf(map));
                insertMap.put("tId", map.get("tId"));
                if((String.valueOf(errorMsg)).equals("") || (String.valueOf(errorMsg) == null) || String.valueOf(errorMsg).length() == 0){
                    insertMap.put("resultCode", "SUCCESS");
                }
                else{
                    insertMap.put("resultCode", "ERROR");
                }
                insertMap.put("resultMsg", String.valueOf(errorMsg));
                insertMap.put("muMemberId", paramMap.get("loginMemberId"));

                webLogHistoryService.insertLogHistory(insertMap, visitLogParamMap);
            }
            catch (Exception e) {
                e.printStackTrace();
            }
        }
        log.debug("WebAppContentsController insertAppContents END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }

    /**
     * 앱 콘텐츠 정보 수정
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webappcontents/updateAppContents.do")
    public ModelAndView updateAppContents(HttpSession session,HttpServletRequest request, HttpServletResponse response, @RequestParam(value = "file", required = false) MultipartFile file, @RequestParam(value = "file2", required = false) MultipartFile file2) {
        log.debug("WebAppContentsController updateAppContents START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        StringBuffer errorMsg = new StringBuffer();

        try{
            if(!webCheckLogin(session)){
                return null;
            }
            else{
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                paramMap.put("regId", String.valueOf(session.getAttribute("loginMemberId")));
                paramMap.put("modId", String.valueOf(session.getAttribute("loginMemberId")));
                map = webAppContentsService.updateAppContents(paramMap,file, file2);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            errorMsg.append(e);
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }

            try {
                HashMap<String, Object> visitLogParamMap = RequestLogUtil.getVisitLogParameterMap(request);
                HashMap<String, Object> insertMap = new HashMap<String, Object>();

                insertMap.put("url", "/webappcontents/updateAppContents.do");
                insertMap.put("func", "updateAppContents");
                insertMap.put("funcName", "앱 콘텐츠 수정");
                insertMap.put("service", "webAppContentsService");
                insertMap.put("serviceName", "앱 콘텐츠 수정");
                insertMap.put("requestValue", String.valueOf(paramMap));
                insertMap.put("responseValue", String.valueOf(map));
                insertMap.put("tId", map.get("tId"));
                if((String.valueOf(errorMsg)).equals("") || (String.valueOf(errorMsg) == null) || String.valueOf(errorMsg).length() == 0){
                    insertMap.put("resultCode", "SUCCESS");
                }
                else{
                    insertMap.put("resultCode", "ERROR");
                }
                insertMap.put("resultMsg", String.valueOf(errorMsg));
                insertMap.put("muMemberId", paramMap.get("loginMemberId"));

                webLogHistoryService.insertLogHistory(insertMap, visitLogParamMap);
            }
            catch (Exception e) {
                e.printStackTrace();
            }
        }
        log.debug("WebAppContentsController updateAppContents END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }


    /**
     * 앱 콘텐츠 정보 삭제
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webappcontents/deleteAppContents.do")
    public ModelAndView deleteAppContents(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
        log.debug("WebAppContentsController deleteAppContents START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        StringBuffer errorMsg = new StringBuffer();

        try{
            if(!webCheckLogin(session)){
                return null;
            }
            else{
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                paramMap.put("regId", String.valueOf(session.getAttribute("loginMemberId")));
                paramMap.put("modId", String.valueOf(session.getAttribute("loginMemberId")));
                map = webAppContentsService.deleteAppContents(paramMap);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            errorMsg.append(e);
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }

            try {
                HashMap<String, Object> visitLogParamMap = RequestLogUtil.getVisitLogParameterMap(request);
                HashMap<String, Object> insertMap = new HashMap<String, Object>();

                insertMap.put("url", "/webappcontents/deleteAppContents.do");
                insertMap.put("func", "deleteAppContents");
                insertMap.put("funcName", "앱 콘텐츠 삭제");
                insertMap.put("service", "webAppContentsService");
                insertMap.put("serviceName", "앱 콘텐츠 삭제");
                insertMap.put("requestValue", String.valueOf(paramMap));
                insertMap.put("responseValue", String.valueOf(map));
                insertMap.put("tId", map.get("tId"));
                if((String.valueOf(errorMsg)).equals("") || (String.valueOf(errorMsg) == null) || String.valueOf(errorMsg).length() == 0){
                    insertMap.put("resultCode", "SUCCESS");
                }
                else{
                    insertMap.put("resultCode", "ERROR");
                }
                insertMap.put("resultMsg", String.valueOf(errorMsg));
                insertMap.put("muMemberId", paramMap.get("loginMemberId"));

                webLogHistoryService.insertLogHistory(insertMap, visitLogParamMap);
            }
            catch (Exception e) {
                e.printStackTrace();
            }
        }
        log.debug("WebAppContentsController deleteAppContents END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }
}

